// verzia beta9 - delphi 5

unit KorUnit;

interface

uses
  Classes, Windows, Graphics, ExtCtrls, Messages, SysUtils;

type
  Kor=class
  private
    XSur0,YSur0,Smer0:real;
    Dole0:boolean;
    FP0:TColor;
    HP0:integer;
    Ukazana0:boolean;
    pobrys:array of real;
    fobrys:TColor;
    hobrys:integer;
    procedure Ukaz0(c:TCanvas);
  public
    constructor Create(x:real = 0; y:real = 0; u:real = 0);
    destructor Destroy; override;

    procedure Dopredu(d:real); virtual;
    procedure Vpravo(u:real); virtual;
    procedure Vlavo(u:real); virtual;
    procedure ZmenSmer(u:real); virtual;
    procedure ZmenXY(x,y:real); virtual;
    procedure PresunXY(x,y:real); virtual;
    procedure PH; virtual;
    procedure PD; virtual;
    procedure ZmenPero(nd:boolean); virtual;
    procedure ZmenFP(nfp:TColor); virtual;
    procedure ZmenHP(nhp:integer); virtual;
    procedure Ukaz; virtual;
    procedure Skry; virtual;
    procedure ZmenTvar(const obrys:array of real); virtual;
    procedure ZmenFarbuTvaru(f:TColor); virtual;
    procedure ZmenHrubkuTvaru(h:integer); virtual;

    procedure Pis(const s:string); virtual;
    function  Smerom(x,y:real):real; virtual;
    procedure Vypln(fv:TColor); virtual;
    function  Vzd(x,y:real):real; virtual;
    function  Blizko(x,y:real):boolean; virtual;

    property  XSur:real read XSur0;
    property  YSur:real read YSur0;
    property  Smer:real read Smer0 write ZmenSmer;
    property  Dole:boolean read Dole0 write ZmenPero;
    property  FP:TColor read FP0 write ZmenFP;
    property  HP:integer read HP0 write ZmenHP;
    property  FarbaTvaru:TColor read fobrys write ZmenFarbuTvaru;
    property  HrubkaTvaru:integer read hobrys write ZmenHrubkuTvaru;
  end;

//////////////////////////////////////////////////////////////////////////////////////////

const rad=pi/180;
      deg=180/pi;

var X0,Y0:integer;     { stred obrazovky = suradnice (0,0) }
    spomal:integer = 0;

procedure Zmaz(fpoz:TColor = clWhite);
procedure Cakaj(MilliSec:Longint);

procedure inicializuj(p:TImage);
procedure DokresliKory(Handle:HWnd; var Message: TWMPaint);
procedure ZrusKory;
procedure test;
procedure test1;
function Naraz(blokuj:boolean = true):boolean;

//////////////////////////////////////////////////////////////////////////////////////////

implementation

uses Forms;

var g:TCanvas;
    membitmap:TBitmap = nil;
    blok:boolean = false;
    Left,Top:integer;
    pukaz:integer = 0;
    kory:array of kor;
    maxkor:integer = -1;

//////////////////////////////////////////////////////////////////////////////////////////

constructor Kor.Create(x,y,u:real);
var i:integer;
begin
  XSur0:=x; YSur0:=y; Smer0:=u;
  FP0:=clBlack; HP0:=1;
  Dole0:=true; Ukazana0:=false;
  pobrys:=nil; fobrys:=clGreen; hobrys:=1;
  i:=0; while (i<=maxkor) and (kory[i]<>nil) do inc(i);
  if i>high(kory) then SetLength(kory, Length(kory)+10);
  kory[i]:=self; if i>maxkor then maxkor:=i;
  test;
end;

destructor Kor.Destroy;
var i:integer;
begin
  if Ukazana0 then dec(pukaz);
  pobrys:=nil;
  i:=0; while (i<=maxkor) and (kory[i]<>self) do inc(i);
  if i<=maxkor then kory[i]:=nil;
  test;
  inherited;
end;

procedure Kor.Vpravo(u:real);
begin
  ZmenSmer(Smer0+u);
end;

procedure Kor.Vlavo(u:real);
begin
  ZmenSmer(Smer0-u);
end;

procedure Kor.ZmenSmer(u:real);
begin
  Smer0:=u;
  while Smer0<0 do Smer0:=Smer0+360;
  while Smer0>=360 do Smer0:=Smer0-360;
  test;
end;

procedure Kor.Dopredu(d:real);
begin
  ZmenXY(XSur0+sin(Smer0*rad)*d,YSur0+cos(Smer0*rad)*d);
end;

procedure Kor.ZmenXY(x,y:real);
begin
  if not Dole0 then PresunXY(x,y)
  else
    begin
      g.Brush.Style:=bsSolid;
      g.Pen.Color:=FP0;
      g.Pen.Width:=HP0;
      g.PolyLine([Point(round(XSur0)+X0,Y0-round(YSur0)),Point(round(x)+X0,Y0-round(y))]);
      XSur0:=x; YSur0:=y;
      test;
    end;
end;

procedure Kor.PresunXY(x,y:real);
begin
  XSur0:=x; YSur0:=y;
  g.MoveTo(round(XSur0)+X0,Y0-round(YSur0));
  test;
end;

procedure Kor.PH;
begin
  Dole0:=false;
  test;
end;

procedure Kor.PD;
begin
  Dole0:=true;
  test;
end;

procedure Kor.ZmenPero(nd:boolean);
begin
  if nd then PD else PH;
end;

procedure Kor.ZmenFP(nfp:TColor);
begin
  FP0:=nfp;
  test;
end;

procedure Kor.ZmenHP(nhp:integer);
begin
  HP0:=nhp;
  test;
end;

//////////////////////////////////////////////////////////////////////////////////////////

procedure Kor.Vypln(fv:TColor);
var x,y:integer;
begin
  x:=round(XSur0)+X0; y:=Y0-round(YSur0);
  g.Brush.Color:=fv;
  g.Brush.Style:=bsSolid;
  g.FloodFill(x,y,g.Pixels[x,y],fsSurface);
  test;
end;

function Kor.Smerom(x,y:real):real;
var u:real;
begin
  x:=x-XSur0; y:=y-YSur0;
  if y=0 then
    if x=0 then u:=0
    else if x<0 then u:=270 else u:=90
  else if y>0 then
    if x>=0 then u:=arctan(x/y)*deg
    else u:=360-arctan(-x/y)*deg
  else
    if x>=0 then u:=180-arctan(-x/y)*deg
    else u:=180+arctan(x/y)*deg;
  Result:=u;
  test;
end;

function Kor.Vzd(x,y:real):real;
begin
  Result:=sqrt(sqr(x-XSur0)+sqr(y-YSur0));
end;

function Kor.Blizko(x,y:real):boolean;
begin
  Result:=Ukazana0 and (sqr(x-XSur0)+sqr(y-YSur0)<100);
end;

procedure Kor.Pis(const s:string);
begin
  g.Font.Color:=FP0;
  g.TextOut(round(XSur0)+X0,Y0-round(YSur0),s);
  test;
end;

//////////////////////////////////////////////////////////////////////////////////////////

procedure Kor.Ukaz;
begin
  if not Ukazana0 then
    begin
      if pobrys=nil then
        begin
          ZmenTvar([90,8,-105,30.9,-150,30.9,-105,8]);
//          ZmenTvar([120,11.5,-135,38.6,-150,38.6,-135,11.5]); fobrys:=clred;
        end;
      Ukazana0:=true; inc(pukaz);
    end;
  test
end;

procedure Kor.Skry;
begin
  if Ukazana0 then dec(pukaz);
  Ukazana0:=false; test
end;

procedure Kor.ZmenTvar(const obrys:array of real);
var i:integer;
begin
  SetLength(pobrys,Length(obrys));
  for i:=0 to high(obrys) do pobrys[i]:=obrys[i];
  test;
end;

procedure Kor.ZmenFarbuTvaru(f:TColor);
begin
  fobrys:=f; test;
end;

procedure Kor.ZmenHrubkuTvaru(h:integer);
begin
  if h<=0 then h:=1; hobrys:=h; test;
end;

procedure Kor.Ukaz0(c:TCanvas);
var i:integer;
    x1,y1,s1:real;
begin
  if not Ukazana0 then exit;
  if pobrys=nil then exit;         
  c.MoveTo(round(XSur0)+X0,Y0-round(YSur0));
  c.Pen.Color:=fobrys;
  c.Pen.Width:=hobrys;
  c.Pen.Style:=psSolid;
  x1:=XSur0; y1:=YSur0; s1:=Smer0;
  for i:=low(pobrys) to high(pobrys) do
    begin
      if not odd(i) then s1:=s1+pobrys[i]
      else if pobrys[i]<>0 then
        begin
          x1:=x1+sin(s1*rad)*pobrys[i]; y1:=y1+cos(s1*rad)*pobrys[i];
          c.LineTo(round(x1)+X0,Y0-round(y1));
        end;
    end;
end;

//////////////////////////////////////////////////////////////////////////////////////////

procedure Zmaz(fpoz:TColor);
begin
  g.Brush.Color:=fpoz;
  g.Brush.Style:=bsSolid;
  g.FillRect(Rect(0,0,membitmap.width,membitmap.height));
  g.Brush.Style:=bsClear;
  test;
end;

procedure Cakaj(MilliSec:Longint);
var TimeOut:TDateTime;
begin
  TimeOut:=Now + EncodeTime(0,MilliSec div 60000,(MilliSec div 1000) mod 60,MilliSec mod 1000);
  while Now < TimeOut do Application.ProcessMessages;
end;

type TMyCanvas=class(TCanvas) end;

procedure test1;
begin
  TMyCanvas(g).Changed;
  InvalidateRect(Application.MainForm.Handle,nil,false);

  if spomal>0 then cakaj(spomal)
  else Application.ProcessMessages;
end;

procedure test;
begin
  if not blok then test1;
end;

function naraz(blokuj:boolean):boolean;
begin
  Result:=blok; blok:=blokuj; test1;
end;

procedure DokresliKory(Handle:HWnd; var Message: TWMPaint);
var DC:hdc;
    PS: TPaintStruct;
    i,SaveIndex:integer;
begin
  if pukaz=0 then exit;
  with membitmap do
    BitBlt(canvas.Handle,0,0,width,height,g.Handle,0,0,SRCCOPY);
  for i:=0 to maxkor do
    if kory[i]<>nil then kory[i].Ukaz0(membitmap.Canvas);
  DC:=BeginPaint(Handle,PS);
  try
    SaveIndex:=SaveDC(DC);
    with membitmap do
      BitBlt(DC,Left,Top,width,height,canvas.Handle,0,0,SRCCOPY);
    RestoreDC(DC,SaveIndex);
  finally
    EndPaint(Handle, PS);
  end;
end;

procedure ZrusKory;
var i:integer;
begin
  for i:=0 to maxkor do kory[i].Free;
end;

procedure inicializuj(p:TImage);
begin
  g:=p.Canvas;
  membitmap:=TBitmap.create;
  membitmap.width:=p.width;
  membitmap.height:=p.height;
  x0:=p.width div 2; y0:=p.height div 2;
  Left:=p.Left; Top:=p.Top;
end;

initialization
finalization
  membitmap.free;
end.

